#ifndef CHierDisplays_H
#define CHierDisplays_H

#include "CDisplay.H"
#include "CHierDisplayInformation.H"
#include "cluster.H"

class CHierDisplay : public CDisplay
{
public:
	CHierDisplayInformation* hier_info;

    //all_* means data that have not been distorted in data space. They are read from files.. 
    Cluster* all_cluster;
    Cluster* cluster;
    bool show_dimcluster_band;
    bool show_two_axes;
    bool show_wide_axes;

protected:
	double current_opacity;


public:
	CHierDisplay(CHierDisplayInformation* hier_info);
	~CHierDisplay();

    //draw the canvas
    void Draw();
	
protected:
	//set this->current_opoacity;
	void SetCurrentOpacity(double opacity);
	
	//draw clusters in unbrushed region;
	void DrawUnbrushedRegion();
	//draw clusters in brushed region;
	void DrawBrushedRegion();
	//Given left limit, right limit and level of detail, draw clusters inside this region.
	void DrawClusters( double left_limit, double right_limit, double level_of_detail, 
								   bool brushed_color );
    void DrawClusters( bool brushed );
    void TraceDrawBrushedClusters( Cluster node );
    void TraceDrawUnbrushedClusters( Cluster node );
	void DrawSingleCluster1(Cluster &c, bool brushed);

	
	//functions need to be written in subclasses;
	//draw a single cluster, to be rewritten in subclasses;
	virtual void DrawSingleCluster(Cluster &c, bool brushed);
    virtual void DrawSingleClusterWithTwoAxes(Cluster &c, ARR<double> mean_max, ARR<double> mean_min, ARR<double> max_max, 
                                                ARR<double> max_min, ARR<double> min_max, ARR<double> min_min, bool brushed);
	//set parameters used for drawing, to be rewritten in subclasses;
	virtual void SetParameters();
	//free space used for drawing; to be rewritten by subclasses;
	virtual void FreeSpace();
	virtual void DrawAxes();
};

#endif

