//modified by Jing Yang after 7/6/2001
#include "CSunburstDimClusterTree.H"
#include "stdio.h"
#include "XmdvTool.H"
#include <string.h>

CSunburstDimClusterTree::CSunburstDimClusterTree() : CSunburstClusterTree()
{
}


CSunburstDimClusterTree::~CSunburstDimClusterTree()
{

}

//build the dim cluster tree according to a file;
//fname: name of the file;
bool CSunburstDimClusterTree::BuildSunburstDimClusterTreeFromFile(const char* fname)
{
    int i;
    assert(dataset);

	//read the nodes into arrays from the file;
    FILE *fptr = fopen(fname,"r");
    if (fptr==NULL) 
        return false;

//    dim_cluster_file = strdup(fname);

    // Get file size
    int num_nodes;
    if (fscanf(fptr, "%d\n", &num_nodes)<=0)
    {
        printf("Error reading the first line of the file %s\n", fname);
        printf("Format of the first line: #nodes\n");
        return false;
    }
    // Allocate space for all node pointers and parent_ids;
    //
    ARR<CSunburstCluster *> nodes;
	ARR<int> parent_ids;

	nodes.SetLen(num_nodes);
    parent_ids.SetLen(num_nodes);

	for ( i = 0; i < num_nodes; i++ )
	{
		nodes[i] = NULL;
		parent_ids[i] = -2;
	}

    printf("Number of dimension cluster nodes=%d\n", num_nodes);


    for(i=0; i<num_nodes; i++) 
	{
		nodes[i] = NULL;
    }

    int id, okc_id;
	char temp_name[50];
	for(i = 0; i < num_nodes; i++)
	{
		fscanf(fptr, "%d", &id);
		nodes[id] = new CSunburstDimCluster();
		fscanf(fptr, "%d %d %lf %d", &parent_ids[id], &(nodes[id]->entries), &(nodes[id]->radius), &okc_id);
        ((CSunburstDimCluster *)nodes[id])->okc_id = okc_id;
        if ( okc_id >= 0 )
            strcpy(temp_name, dataset->names[okc_id]);
        else
            sprintf(temp_name, "$%1d", id);

		((CSunburstDimCluster *)nodes[id])->dim_name = new char[strlen(temp_name)+1];
		strcpy(((CSunburstDimCluster *)nodes[id])->dim_name, temp_name);
	}
    
	fclose(fptr);

	//construct the dim cluster tree according to the arrays;
	if ( ConstructSunburstClusterTree(num_nodes, nodes, parent_ids) )
    {
        //ResetNames();
        return true;
    }
    else
    {
        return false;
    }
}


void CSunburstDimClusterTree::ResetNames()
{
	((CSunburstDimCluster *)root)->ResetNames();
}

